Zen API

- Home
- Help Topics
- Types by Category
- All Types
- Files

All Classes Files Functions Variables Typedefs Macros Groups Pages
Public Member Functions
kAssembly Class Reference
kApi

## Description

Represents a library of types.

An assembly represents a collection of types. Typically, one assembly is defined per library or application.

The kAssembly_Enumerate method can be used to get a list of all loaded assemblies. The kAssemblyOf macro can be used to obtain a handle to a specific type assembly using the compile-time assembly symbol.

//prints a list of supplemental assemblies that have been constructed (i.e., assemblies other than kApiLib)
kStatus PrintOtherAssemblies()
{
kAssembly coreAssembly = kAssemblyOf(kApiLib);
kArrayList assemblyList = kNULL;
kSize i;
kTry
{
//get a list of the loaded assemblies
kTest(kArrayList_Construct(&assemblyList, kTypeOf(kAssembly), 0, kNULL));
kTest(kAssembly_Enumerate(assemblyList));
//print information for all assemblies except kApiLib
for (i = 0; i < kArrayList_Count(assemblyList); ++i)
{
kAssembly assembly = kArrayList_As_(assemblyList, i, kAssembly);
if (assembly != coreAssembly)
{
printf("%s (%u types)\n", kAssembly_Name(assembly), (k32u)kAssembly_TypeCount(assembly));
}
}
}
kFinally
{
//dispose the list of assemblies; each assembly handle returned by kAssembly_Enumerate
//is a reference-counted instance that must be destroyed
kObject_Dispose(assemblyList);
kEndFinally();
}
return kOK;
}
Inheritance diagram for kAssembly:

## Public Member Functions
kStatus | kAssembly_AddLoadHandler (kCallbackFx function, kPointer receiver)
| Adds a callback to be notified when a new assembly is loaded. More...
kStatus | kAssembly_AddUnloadedHandler (kCallbackFx function, kPointer receiver)
| Adds a callback to be notified after unloading an assmebly. More...
kStatus | kAssembly_AddUnloadHandler (kCallbackFx function, kPointer receiver)
| Adds a callback to be notified just prior to unloading an assembly. More...
kStatus | kAssembly_Enumerate (kArrayList assemblies)
| Gets a list of the currently-loaded assemblies. More...
kStatus | kAssembly_FindType (kAssembly assembly, const kChar *name, kType *type)
| Finds a type by name. More...
const kChar * | kAssembly_Name (kAssembly assembly)
| Gets the assembly name. More...
kStatus | kAssembly_RemoveLoadHandler (kCallbackFx function, kPointer receiver)
| Removes a callback that was registered with the kAssembly_AddLoadHandler function. More...
kStatus | kAssembly_RemoveUnloadedHandler (kCallbackFx function, kPointer receiver)
| Removes a callback that was registered with the kAssembly_AddUnloadedHandler function. More...
kStatus | kAssembly_RemoveUnloadHandler (kCallbackFx function, kPointer receiver)
| Removes a callback that was registered with the kAssembly_AddUnloadHandler function. More...
kType | kAssembly_TypeAt (kAssembly assembly, kSize index)
| Gets the type at a particular index within an assembly. More...
kSize | kAssembly_TypeCount (kAssembly assembly)
| Gets the number of types in an assembly. More...
kVersion | kAssembly_Version (kAssembly assembly)
| Gets the assembly version. More...
kAlloc | kObject_Alloc (kObject object)
| Gets the memory allocator associated with this object. More...
kStatus | kObject_Clone (kObject *object, kObject source, kAlloc allocator)
| Constructs a new object by copying an existing object, including any aggregated child elements. More...
kStatus | kObject_Destroy (kObject object)
| Destroys the object. More...
kStatus | kObject_Dispose (kObject object)
| Destroys the object and any aggregated child elements. More...
kBool | kObject_Equals (kObject object, kObject other)
| Determines whether the object is equal to another object. More...
kSize | kObject_HashCode (kObject object)
| Gets a hash code representing the state of this object. More...
kBool | kObject_Is (kObject object, kType type)
| Determines whether this object is an instance of the specified type. More...
kBool | kObject_IsShared (kObject object)
| Reports whether the object is currently shared (reference count greater than one). More...
kStatus | kObject_SetPool (kObject object, kObjectPool pool)
| Sets the object pool associated with this object. More...
kStatus | kObject_Share (kObject object)
| Increments the reference count associated with this object. More...
kSize | kObject_Size (kObject object)
| Estimates the memory consumed by this object, including any aggregated child elements. More...
kType | kObject_Type (kObject object)
| Returns the type of the object. More...

## Member Function Documentation

kStatus kAssembly_AddLoadHandler | ( | kCallbackFx | function,
|  | kPointer | receiver
| ) |  |

Adds a callback to be notified when a new assembly is loaded.

The callback will be notified immediately after the assembly is loaded. The callback 'sender' argument will be the handle of the loaded assembly.

The static assembly lock (an internal, recursive, mutual exclusion structure) is held for the duration of callback invocation. Callback functions should be structured accordingly to avoid the potential for deadlock.

Parameters

  function | Callback function.
  receiver | Context pointer for callback function.

Returns
  Operation status.

kStatus kAssembly_AddUnloadedHandler | ( | kCallbackFx | function,
|  | kPointer | receiver
| ) |  |

Adds a callback to be notified after unloading an assmebly.

The callback will be notified just after the release of the assembly's static types, and just prior to destroying the assembly handle. The callback 'sender' argument will be the handle of the assembly that is being unloaded.

The static assembly lock (an internal, recursive, mutual exclusion structure) is held for the duration of callback invocation. Callback functions should be structured accordingly to avoid the potential for deadlock.

Parameters

  function | Callback function.
  receiver | Context pointer for callback function.

Returns
  Operation status.

kStatus kAssembly_AddUnloadHandler | ( | kCallbackFx | function,
|  | kPointer | receiver
| ) |  |

Adds a callback to be notified just prior to unloading an assembly.

The callback will be notified just prior to unloading the assembly. The callback 'sender' argument will be the handle of the assembly that is being unloaded.

The static assembly lock (an internal, recursive, mutual exclusion structure) is held for the duration of callback invocation. Callback functions should be structured accordingly to avoid the potential for deadlock.

Parameters

  function | Callback function.
  receiver | Context pointer for callback function.

Returns
  Operation status.

kStatus kAssembly_Enumerate | ( | kArrayList | assemblies | ) |

Gets a list of the currently-loaded assemblies.

Each assembly returned by this function is a reference-counted instance that should be destroyed when no longer needed.

Parameters

  assemblies | Receives references to loaded assemblies.

Returns
  Operation status.

kStatus kAssembly_FindType | ( | kAssembly | assembly,
|  | const kChar * | name,
|  | kType * | type
| ) |  |

Finds a type by name.

Parameters

  assembly | Assembly to search.
  name | Type name.
  type | Receives the type.

Returns
  Operation status (kERROR_NOT_FOUND on lookup failure).

const kChar * kAssembly_Name | ( | kAssembly | assembly | ) |

Gets the assembly name.

Parameters

  assembly | Assembly.

Returns
  Assembly name.

kStatus kAssembly_RemoveLoadHandler | ( | kCallbackFx | function,
|  | kPointer | receiver
| ) |  |

Removes a callback that was registered with the kAssembly_AddLoadHandler function.

Parameters

  function | Callback function.
  receiver | Context pointer for callback function.

Returns
  Operation status.

kStatus kAssembly_RemoveUnloadedHandler | ( | kCallbackFx | function,
|  | kPointer | receiver
| ) |  |

Removes a callback that was registered with the kAssembly_AddUnloadedHandler function.

Parameters

  function | Callback function.
  receiver | Context pointer for callback function.

Returns
  Operation status.

kStatus kAssembly_RemoveUnloadHandler | ( | kCallbackFx | function,
|  | kPointer | receiver
| ) |  |

Removes a callback that was registered with the kAssembly_AddUnloadHandler function.

Parameters

  function | Callback function.
  receiver | Context pointer for callback function.

Returns
  Operation status.

kType kAssembly_TypeAt | ( | kAssembly | assembly,
|  | kSize | index
| ) |  |

Gets the type at a particular index within an assembly.

Parameters

  assembly | Assembly.
  index | Type index.

Returns
  Type.

kSize kAssembly_TypeCount | ( | kAssembly | assembly | ) |

Gets the number of types in an assembly.

Parameters

  assembly | Assembly.

Returns
  Operation status.

kVersion kAssembly_Version | ( | kAssembly | assembly | ) |

Gets the assembly version.

Parameters

  assembly | Assembly.

Returns
  Version number.

kAlloc kObject_Alloc | ( | kObject | object | ) |
| inherited

Gets the memory allocator associated with this object.

Most objects are constructed with an allocator, which is used to allocate the memory required by the object. Objects retain a reference to this allocator to enable further allocations and to free memory when the object is destroyed.

Parameters

  object | Object.

Returns
  Memory allocator.

See also
  kAlloc, kObject_Alloc_

kStatus kObject_Clone | ( | kObject * | object,
|  | kObject | source,
|  | kAlloc | allocator
| ) |  |
| inherited

Constructs a new object by copying an existing object, including any aggregated child elements.

If the source object is an object collection (e.g. kArrayList<kString>), any aggregated child objects are also cloned. In this case, the kObject_Dispose method can be used to free the cloned collection and its associated elements.

This method will fail if the source object (or an aggregated child element) does not support cloning.

Parameters

  object | Receives the constructed object.
  source | Source object.
  allocator | Memory allocator (or kNULL for default).

Returns
  Operation status.

See also
  kObject_Dispose

kStatus kObject_Destroy | ( | kObject | object | ) |
| inherited

Destroys the object.

The kObject_Destroy method destroys the object itself and any resources that are owned by the object. See Object Destruction for more information.

When an object is destroyed (or disposed), its reference count is decremented. The object is only truly destroyed when the reference count reaches zero. See Reference Counting for more information.

Parameters

  object | Object (or kNULL).

Returns
  Operation status.

See also
  Object Destruction, Reference Counting

kStatus kObject_Dispose | ( | kObject | object | ) |
| inherited

Destroys the object and any aggregated child elements.

The kObject_Dispose method destroys the object itself, any resources that are owned by the object, and if the object represents a collection of objects, any child objects in the collection. See Object Destruction for more information.

When an object is destroyed (or disposed), its reference count is decremented. The object is only truly destroyed when the reference count reaches zero. See Reference Counting for more information.

Parameters

  object | Object (or kNULL).

Returns
  Operation status.

See also
  Object Destruction, Reference Counting

kBool kObject_Equals | ( | kObject | object,
|  | kObject | other
| ) |  |
| inherited

Determines whether the object is equal to another object.

By default, objects are compared by reference; objects are considered equal if the given handles refer to the same object instance. However, some classes override the Equals method to provide a more meaningful comparison (e.g. kString).

Parameters

  object | Object.
  other | Object for comparison.

Returns
  kTRUE if the objects are equal.

kSize kObject_HashCode | ( | kObject | object | ) |
| inherited

Gets a hash code representing the state of this object.

By default, objects return a hash code based on the object handle value. However, some classes override the HashCode method to provide a more useful hash (e.g. kString).

Parameters

  object | Object.

Returns
  Hash code.

kBool kObject_Is | ( | kObject | object,
|  | kType | type
| ) |  |
| inherited

Determines whether this object is an instance of the specified type.

This function compares the type of this object with the given type. An object is considered to be an instance of a given type if a) the type represents a class and this object inherits from (or instantiates) that class, or b) the type represents an interface and this object implements the interface.

Parameters

  object | Object.
  type | Type.

Returns
  kTRUE if the object is of the specified type; otherwise kFALSE.

See also
  kObject_Is_, kType_Is

kBool kObject_IsShared | ( | kObject | object | ) |
| inherited

Reports whether the object is currently shared (reference count greater than one).

Objects are initialized with a reference count of one. The kObject_Share method can be used to increment the reference count. The kObject_Destroy and kObject_Dispose methods decrease the reference count, and when the reference count reaches zero, the object is actually destroyed/disposed.

This method can be used to determine if the reference count of an object is currently greater than one.

This method is thread-safe.

Parameters

  object | Object.

Returns
  kTRUE if the object is shared; kFALSE otherwise.

See also
  Reference Counting, kObject_Share

kStatus kObject_SetPool | ( | kObject | object,
|  | kObjectPool | pool
| ) |  |
| inherited

Sets the object pool associated with this object.

Object pools can be used to implement custom lifecycle management. If an object has an assigned pool, then the kObjectPool_Reclaim method will be called just prior to destruction, to provide an opportunity for the object to be reclaimed.

Parameters

  object | Object.
  pool | Pool object (or kNULL to clear the pool assignment).

Returns
  Operation status.

kStatus kObject_Share | ( | kObject | object | ) |
| inherited

Increments the reference count associated with this object.

This method is thread-safe.

Parameters

  object | Object.

Returns
  Operation status.

See also
  reference-counting

kSize kObject_Size | ( | kObject | object | ) |
| inherited

Estimates the memory consumed by this object, including any aggregated child elements.

This method can be optionally overridden by kObject-derived classes to report the amount of memory consumed by an object. The default implementation reports only the size of the class instance (additional allocations performed by the class are excluded).

Parameters

  object | Object.

Returns
  Object size, in bytes.

kType kObject_Type | ( | kObject | object | ) |
| inherited

Returns the type of the object.

Each object is an instance of a specific class type. The type handle returned by this function can be used to learn about the class.

Parameters

  object | Object.

Returns
  Type.

See also
  kType, kObject_Type_

The documentation for this class was generated from the following file:

- kAssembly.h